#!/usr/bin/env python3

'''
Created on 11/02/2025

@author: dedson
'''


import sqlalchemy
import sqlalchemy.orm

from sqlalchemy import Column, Integer, String, DateTime, ForeignKey
from sqlalchemy.engine import reflection
from sqlalchemy.orm import relationship, backref
from sqlalchemy.orm.collections import InstrumentedList, InstrumentedDict, InstrumentedSet

from .Base import Base

from jsonweb.encode import to_object
from jsonweb.decode import from_object

@from_object()
@to_object()
class Value(Base):
	'''
	a single value instance as a fundamental type
	'''
	
	__tablename__ = 'values'
	
	id			 = Column(Integer, primary_key=True)
	instance_id  = Column(Integer, ForeignKey('instance.id'))
	value		 = Column(String(256))
	modified	 = Column(DateTime)
	
	def __init__(
		self,
		id=None,
   		instance_id=None,
		value=None,
		modified=None
	):
		self.id = id
		self.instance_id = instance_id
		self.value=value
		self.modified = modified
		return
	  
	def __dir__(self):
		return [
			'id',
			'value',
			'instance_id',
			'modified'
		]

